;///  Petezl 2005  //////////////////////////
;///  Example of using a pen in a window  ///
;////////////////////////////////////////////

.386 
.model flat,stdcall 
option casemap:none 
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD 

include \masm32\include\windows.inc 
include \masm32\include\user32.inc 
include \masm32\include\kernel32.inc 
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib 

include \masm32\include\gdi32.inc  ;// You need these two
includelib \masm32\lib\gdi32.lib 

.data 
ClassName db "Petezl_WinClass",0 
AppName db "Pen in a window",0 

.data? 
hInstance HINSTANCE ? 
CommandLine LPSTR ? 

.code 
start: 
invoke GetModuleHandle, NULL 
mov hInstance,eax 
invoke GetCommandLine
mov CommandLine,eax 
invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT 
invoke ExitProcess,eax 

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD 
LOCAL wc:WNDCLASSEX 
LOCAL msg:MSG 
LOCAL hwnd:HWND 
mov wc.cbSize,SIZEOF WNDCLASSEX 
mov wc.style, CS_HREDRAW or CS_VREDRAW 
mov wc.lpfnWndProc, OFFSET WndProc 
mov wc.cbClsExtra,NULL 
mov wc.cbWndExtra,NULL 
push hInst 
pop wc.hInstance 
mov wc.hbrBackground,COLOR_WINDOW+1 
mov wc.lpszMenuName, 0h 
mov wc.lpszClassName,OFFSET ClassName 
invoke LoadIcon,NULL,IDI_APPLICATION 
mov wc.hIcon,eax 
mov wc.hIconSm,eax 
invoke LoadCursor,NULL,IDC_ARROW 
mov wc.hCursor,eax 
invoke RegisterClassEx, addr wc 
invoke CreateWindowEx,WS_EX_CLIENTEDGE,ADDR ClassName, \ 
ADDR AppName, WS_OVERLAPPEDWINDOW,\ 
CW_USEDEFAULT, CW_USEDEFAULT,\ 
200,150,NULL,NULL, hInst,NULL ;window size
mov hwnd,eax 
invoke ShowWindow, hwnd,SW_SHOWNORMAL 
invoke UpdateWindow, hwnd 
.WHILE TRUE 
invoke GetMessage, ADDR msg,NULL,0,0 
.BREAK .IF (!eax) 
invoke TranslateMessage, ADDR msg 
invoke DispatchMessage, ADDR msg 
.ENDW 
mov eax,msg.wParam 
ret 
WinMain endp
; 

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 

LOCAL ps:PAINTSTRUCT 
LOCAL hdc:HDC 

LOCAL hbluePen: DWORD
LOCAL holdPen : DWORD

.IF uMsg==WM_DESTROY 
invoke PostQuitMessage,NULL

.elseif uMsg==WM_CREATE

.elseif uMsg==WM_PAINT 
invoke BeginPaint,hWnd,addr ps 
mov hdc,eax

      invoke CreatePen,PS_SOLID,1, 00ff0000h ;// Create a Blue pen
      mov hbluePen,eax 
      invoke SelectObject,hdc, hbluePen   ;// select the blue pen and save the default on
      mov holdPen,eax
      
      invoke Ellipse,hdc,180,110,10,10 ;width,depth,start posx,start posy

      invoke SelectObject, hdc, holdPen
      invoke DeleteObject, eax ;(or hbluePen)   ;// delete it

invoke EndPaint,hWnd,addr ps 

.ELSE 
invoke DefWindowProc,hWnd,uMsg,wParam,lParam 
ret 
.ENDIF 
xor eax,eax 
ret 
WndProc endp 

end start 
